package ex.hm;

import blang.core.ConstantSupplier;
import blang.core.DeboxedName;
import blang.core.IntVar;
import blang.core.Model;
import blang.core.ModelBuilder;
import blang.core.ModelComponent;
import blang.core.Param;
import blang.core.RealVar;
import blang.inits.Arg;
import blang.inits.DesignatedConstructor;
import blang.types.StaticUtils;
import blang.types.internals.RealScalar;
import ca.ubc.stat.blang.StaticJavaUtils;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Optional;
import java.util.function.Supplier;

@SuppressWarnings("all")
public class Basic implements Model {
  public static class Builder implements ModelBuilder {
    private boolean fromCommandLine = false;
    
    @Arg
    public Optional<IntVar> numberOfLaunches;
    
    public Basic.Builder setNumberOfLaunches(final IntVar numberOfLaunches) {
      // work around typeRef(..) limitation
      Optional<IntVar> $generated__dummy = null;
      this.numberOfLaunches = Optional.of(numberOfLaunches);
      return this;
    }
    
    @Arg
    public Optional<RealVar> failureProbability;
    
    public Basic.Builder setFailureProbability(final RealVar failureProbability) {
      // work around typeRef(..) limitation
      Optional<RealVar> $generated__dummy = null;
      this.failureProbability = Optional.of(failureProbability);
      return this;
    }
    
    @Arg
    public Optional<IntVar> numberOfFailures;
    
    public Basic.Builder setNumberOfFailures(final IntVar numberOfFailures) {
      // work around typeRef(..) limitation
      Optional<IntVar> $generated__dummy = null;
      this.numberOfFailures = Optional.of(numberOfFailures);
      return this;
    }
    
    public Basic build() {
      // For each optional type, either get the value, or evaluate the ?: expression
      IntVar numberOfLaunches;
      if (this.numberOfLaunches != null && this.numberOfLaunches.isPresent()) {
        numberOfLaunches = this.numberOfLaunches.get();
      } else {
        numberOfLaunches = $generated__6();
      }
      final IntVar __numberOfLaunches = numberOfLaunches;
      RealVar failureProbability;
      if (this.failureProbability != null && this.failureProbability.isPresent()) {
        failureProbability = this.failureProbability.get();
      } else {
        failureProbability = $generated__7(numberOfLaunches);
      }
      final RealVar __failureProbability = failureProbability;
      IntVar numberOfFailures;
      if (this.numberOfFailures != null && this.numberOfFailures.isPresent()) {
        numberOfFailures = this.numberOfFailures.get();
      } else {
        numberOfFailures = $generated__8(numberOfLaunches, failureProbability);
      }
      final IntVar __numberOfFailures = numberOfFailures;
      // Build the instance after boxing params
      return new Basic(
        __failureProbability, 
        __numberOfFailures, 
        new ConstantSupplier(__numberOfLaunches)
      );
    }
  }
  
  @DesignatedConstructor
  public static Basic.Builder builderFromCommandLine() {
    Builder result = new Builder();
    result.fromCommandLine = true;
    return result;
  }
  
  @Param
  private final Supplier<IntVar> $generated__numberOfLaunches;
  
  public IntVar getNumberOfLaunches() {
    return $generated__numberOfLaunches.get();
  }
  
  private final RealVar failureProbability;
  
  public RealVar getFailureProbability() {
    return failureProbability;
  }
  
  private final IntVar numberOfFailures;
  
  public IntVar getNumberOfFailures() {
    return numberOfFailures;
  }
  
  /**
   * Utility main method for posterior inference on this model
   */
  public static void main(final String[] arguments) {
    StaticJavaUtils.callRunner(Builder.class, arguments);
  }
  
  /**
   * Auxiliary method generated to translate:
   * failureProbability
   */
  private static RealVar $generated__0(final IntVar numberOfLaunches, final RealVar failureProbability, final IntVar numberOfFailures) {
    return failureProbability;
  }
  
  /**
   * Auxiliary method generated to translate:
   * 1
   */
  private static RealVar $generated__1() {
    return new blang.core.RealConstant(1);
  }
  
  public static class $generated__1_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__1();
    }
    
    public String toString() {
      return "1";
    }
    
    public $generated__1_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * 1
   */
  private static RealVar $generated__2() {
    return new blang.core.RealConstant(1);
  }
  
  public static class $generated__2_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__2();
    }
    
    public String toString() {
      return "1";
    }
    
    public $generated__2_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * numberOfFailures
   */
  private static IntVar $generated__3(final IntVar numberOfLaunches, final RealVar failureProbability, final IntVar numberOfFailures) {
    return numberOfFailures;
  }
  
  /**
   * Auxiliary method generated to translate:
   * numberOfLaunches
   */
  private static IntVar $generated__4(final RealVar failureProbability, final IntVar numberOfLaunches) {
    return numberOfLaunches;
  }
  
  public static class $generated__4_class implements Supplier<IntVar> {
    public IntVar get() {
      return $generated__4(failureProbability, $generated__numberOfLaunches.get());
    }
    
    public String toString() {
      return "numberOfLaunches";
    }
    
    private final RealVar failureProbability;
    
    private final Supplier<IntVar> $generated__numberOfLaunches;
    
    public $generated__4_class(final RealVar failureProbability, final Supplier<IntVar> $generated__numberOfLaunches) {
      this.failureProbability = failureProbability;
      this.$generated__numberOfLaunches = $generated__numberOfLaunches;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * failureProbability
   */
  private static RealVar $generated__5(final RealVar failureProbability, final IntVar numberOfLaunches) {
    return failureProbability;
  }
  
  public static class $generated__5_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__5(failureProbability, $generated__numberOfLaunches.get());
    }
    
    public String toString() {
      return "failureProbability";
    }
    
    private final RealVar failureProbability;
    
    private final Supplier<IntVar> $generated__numberOfLaunches;
    
    public $generated__5_class(final RealVar failureProbability, final Supplier<IntVar> $generated__numberOfLaunches) {
      this.failureProbability = failureProbability;
      this.$generated__numberOfLaunches = $generated__numberOfLaunches;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * 3
   */
  private static IntVar $generated__6() {
    return new blang.core.IntConstant(3);
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentReal
   */
  private static RealVar $generated__7(final IntVar numberOfLaunches) {
    RealScalar _latentReal = StaticUtils.latentReal();
    return _latentReal;
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0
   */
  private static IntVar $generated__8(final IntVar numberOfLaunches, final RealVar failureProbability) {
    return new blang.core.IntConstant(0);
  }
  
  /**
   * Note: the generated code has the following properties used at runtime:
   *   - all arguments are annotated with a BlangVariable annotation
   *   - params additionally have a Param annotation
   *   - the order of the arguments is as follows:
   *     - first, all the random variables in the order they occur in the blang file
   *     - second, all the params in the order they occur in the blang file
   * 
   */
  public Basic(@DeboxedName("failureProbability") final RealVar failureProbability, @DeboxedName("numberOfFailures") final IntVar numberOfFailures, @Param @DeboxedName("numberOfLaunches") final Supplier<IntVar> $generated__numberOfLaunches) {
    this.$generated__numberOfLaunches = $generated__numberOfLaunches;
    this.failureProbability = failureProbability;
    this.numberOfFailures = numberOfFailures;
  }
  
  /**
   * A component can be either a distribution, support constraint, or another model  
   * which recursively defines additional components.
   */
  public Collection<ModelComponent> components() {
    ArrayList<ModelComponent> components = new ArrayList();
    
    { // Code generated by: failureProbability ~ Beta(1, 1)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.Beta(
          $generated__0($generated__numberOfLaunches.get(), failureProbability, numberOfFailures), 
          new $generated__1_class(), 
          new $generated__2_class()
        )
        );
    }
    { // Code generated by: numberOfFailures | failureProbability, numberOfLaunches ~ Binomial(numberOfLaunches, failureProbability)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.Binomial(
          $generated__3($generated__numberOfLaunches.get(), failureProbability, numberOfFailures), 
          new $generated__4_class(failureProbability, $generated__numberOfLaunches), 
          new $generated__5_class(failureProbability, $generated__numberOfLaunches)
        )
        );
    }
    
    return components;
  }
}
