package ex.hm;

import blang.core.ConstantSupplier;
import blang.core.DeboxedName;
import blang.core.IntVar;
import blang.core.Model;
import blang.core.ModelBuilder;
import blang.core.ModelComponent;
import blang.core.Param;
import blang.core.RealVar;
import blang.inits.Arg;
import blang.inits.DesignatedConstructor;
import blang.types.StaticUtils;
import blang.types.internals.RealScalar;
import ca.ubc.stat.blang.StaticJavaUtils;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Optional;
import java.util.function.Supplier;

@SuppressWarnings("all")
public class BasicReparameterized implements Model {
  public static class Builder implements ModelBuilder {
    private boolean fromCommandLine = false;
    
    @Arg
    public Optional<RealVar> mu;
    
    public BasicReparameterized.Builder setMu(final RealVar mu) {
      // work around typeRef(..) limitation
      Optional<RealVar> $generated__dummy = null;
      this.mu = Optional.of(mu);
      return this;
    }
    
    @Arg
    public Optional<RealVar> s;
    
    public BasicReparameterized.Builder setS(final RealVar s) {
      // work around typeRef(..) limitation
      Optional<RealVar> $generated__dummy = null;
      this.s = Optional.of(s);
      return this;
    }
    
    @Arg
    public Optional<IntVar> numberOfLaunches;
    
    public BasicReparameterized.Builder setNumberOfLaunches(final IntVar numberOfLaunches) {
      // work around typeRef(..) limitation
      Optional<IntVar> $generated__dummy = null;
      this.numberOfLaunches = Optional.of(numberOfLaunches);
      return this;
    }
    
    @Arg
    public Optional<RealVar> failureProbability;
    
    public BasicReparameterized.Builder setFailureProbability(final RealVar failureProbability) {
      // work around typeRef(..) limitation
      Optional<RealVar> $generated__dummy = null;
      this.failureProbability = Optional.of(failureProbability);
      return this;
    }
    
    @Arg
    public Optional<IntVar> numberOfFailures;
    
    public BasicReparameterized.Builder setNumberOfFailures(final IntVar numberOfFailures) {
      // work around typeRef(..) limitation
      Optional<IntVar> $generated__dummy = null;
      this.numberOfFailures = Optional.of(numberOfFailures);
      return this;
    }
    
    public BasicReparameterized build() {
      // For each optional type, either get the value, or evaluate the ?: expression
      RealVar mu;
      if (this.mu != null && this.mu.isPresent()) {
        mu = this.mu.get();
      } else {
        mu = $generated__6();
      }
      final RealVar __mu = mu;
      RealVar s;
      if (this.s != null && this.s.isPresent()) {
        s = this.s.get();
      } else {
        s = $generated__7(mu);
      }
      final RealVar __s = s;
      IntVar numberOfLaunches;
      if (this.numberOfLaunches != null && this.numberOfLaunches.isPresent()) {
        numberOfLaunches = this.numberOfLaunches.get();
      } else {
        numberOfLaunches = $generated__8(mu, s);
      }
      final IntVar __numberOfLaunches = numberOfLaunches;
      RealVar failureProbability;
      if (this.failureProbability != null && this.failureProbability.isPresent()) {
        failureProbability = this.failureProbability.get();
      } else {
        failureProbability = $generated__9(mu, s, numberOfLaunches);
      }
      final RealVar __failureProbability = failureProbability;
      IntVar numberOfFailures;
      if (this.numberOfFailures != null && this.numberOfFailures.isPresent()) {
        numberOfFailures = this.numberOfFailures.get();
      } else {
        numberOfFailures = $generated__10(mu, s, numberOfLaunches, failureProbability);
      }
      final IntVar __numberOfFailures = numberOfFailures;
      // Build the instance after boxing params
      return new BasicReparameterized(
        __failureProbability, 
        __numberOfFailures, 
        new ConstantSupplier(__mu), 
        new ConstantSupplier(__s), 
        new ConstantSupplier(__numberOfLaunches)
      );
    }
  }
  
  @DesignatedConstructor
  public static BasicReparameterized.Builder builderFromCommandLine() {
    Builder result = new Builder();
    result.fromCommandLine = true;
    return result;
  }
  
  @Param
  private final Supplier<RealVar> $generated__mu;
  
  public RealVar getMu() {
    return $generated__mu.get();
  }
  
  @Param
  private final Supplier<RealVar> $generated__s;
  
  public RealVar getS() {
    return $generated__s.get();
  }
  
  @Param
  private final Supplier<IntVar> $generated__numberOfLaunches;
  
  public IntVar getNumberOfLaunches() {
    return $generated__numberOfLaunches.get();
  }
  
  private final RealVar failureProbability;
  
  public RealVar getFailureProbability() {
    return failureProbability;
  }
  
  private final IntVar numberOfFailures;
  
  public IntVar getNumberOfFailures() {
    return numberOfFailures;
  }
  
  /**
   * Utility main method for posterior inference on this model
   */
  public static void main(final String[] arguments) {
    StaticJavaUtils.callRunner(Builder.class, arguments);
  }
  
  /**
   * Auxiliary method generated to translate:
   * failureProbability
   */
  private static RealVar $generated__0(final RealVar mu, final RealVar s, final IntVar numberOfLaunches, final RealVar failureProbability, final IntVar numberOfFailures) {
    return failureProbability;
  }
  
  /**
   * Auxiliary method generated to translate:
   * mu
   */
  private static RealVar $generated__1(final RealVar mu, final RealVar s) {
    return mu;
  }
  
  public static class $generated__1_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__1($generated__mu.get(), $generated__s.get());
    }
    
    public String toString() {
      return "mu";
    }
    
    private final Supplier<RealVar> $generated__mu;
    
    private final Supplier<RealVar> $generated__s;
    
    public $generated__1_class(final Supplier<RealVar> $generated__mu, final Supplier<RealVar> $generated__s) {
      this.$generated__mu = $generated__mu;
      this.$generated__s = $generated__s;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * s
   */
  private static RealVar $generated__2(final RealVar mu, final RealVar s) {
    return s;
  }
  
  public static class $generated__2_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__2($generated__mu.get(), $generated__s.get());
    }
    
    public String toString() {
      return "s";
    }
    
    private final Supplier<RealVar> $generated__mu;
    
    private final Supplier<RealVar> $generated__s;
    
    public $generated__2_class(final Supplier<RealVar> $generated__mu, final Supplier<RealVar> $generated__s) {
      this.$generated__mu = $generated__mu;
      this.$generated__s = $generated__s;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * numberOfFailures
   */
  private static IntVar $generated__3(final RealVar mu, final RealVar s, final IntVar numberOfLaunches, final RealVar failureProbability, final IntVar numberOfFailures) {
    return numberOfFailures;
  }
  
  /**
   * Auxiliary method generated to translate:
   * numberOfLaunches
   */
  private static IntVar $generated__4(final RealVar failureProbability, final IntVar numberOfLaunches) {
    return numberOfLaunches;
  }
  
  public static class $generated__4_class implements Supplier<IntVar> {
    public IntVar get() {
      return $generated__4(failureProbability, $generated__numberOfLaunches.get());
    }
    
    public String toString() {
      return "numberOfLaunches";
    }
    
    private final RealVar failureProbability;
    
    private final Supplier<IntVar> $generated__numberOfLaunches;
    
    public $generated__4_class(final RealVar failureProbability, final Supplier<IntVar> $generated__numberOfLaunches) {
      this.failureProbability = failureProbability;
      this.$generated__numberOfLaunches = $generated__numberOfLaunches;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * failureProbability
   */
  private static RealVar $generated__5(final RealVar failureProbability, final IntVar numberOfLaunches) {
    return failureProbability;
  }
  
  public static class $generated__5_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__5(failureProbability, $generated__numberOfLaunches.get());
    }
    
    public String toString() {
      return "failureProbability";
    }
    
    private final RealVar failureProbability;
    
    private final Supplier<IntVar> $generated__numberOfLaunches;
    
    public $generated__5_class(final RealVar failureProbability, final Supplier<IntVar> $generated__numberOfLaunches) {
      this.failureProbability = failureProbability;
      this.$generated__numberOfLaunches = $generated__numberOfLaunches;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0.5
   */
  private static RealVar $generated__6() {
    return new blang.core.RealConstant(0.5);
  }
  
  /**
   * Auxiliary method generated to translate:
   * 2
   */
  private static RealVar $generated__7(final RealVar mu) {
    return new blang.core.RealConstant(2);
  }
  
  /**
   * Auxiliary method generated to translate:
   * 3
   */
  private static IntVar $generated__8(final RealVar mu, final RealVar s) {
    return new blang.core.IntConstant(3);
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentReal
   */
  private static RealVar $generated__9(final RealVar mu, final RealVar s, final IntVar numberOfLaunches) {
    RealScalar _latentReal = StaticUtils.latentReal();
    return _latentReal;
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0
   */
  private static IntVar $generated__10(final RealVar mu, final RealVar s, final IntVar numberOfLaunches, final RealVar failureProbability) {
    return new blang.core.IntConstant(0);
  }
  
  /**
   * Note: the generated code has the following properties used at runtime:
   *   - all arguments are annotated with a BlangVariable annotation
   *   - params additionally have a Param annotation
   *   - the order of the arguments is as follows:
   *     - first, all the random variables in the order they occur in the blang file
   *     - second, all the params in the order they occur in the blang file
   * 
   */
  public BasicReparameterized(@DeboxedName("failureProbability") final RealVar failureProbability, @DeboxedName("numberOfFailures") final IntVar numberOfFailures, @Param @DeboxedName("mu") final Supplier<RealVar> $generated__mu, @Param @DeboxedName("s") final Supplier<RealVar> $generated__s, @Param @DeboxedName("numberOfLaunches") final Supplier<IntVar> $generated__numberOfLaunches) {
    this.$generated__mu = $generated__mu;
    this.$generated__s = $generated__s;
    this.$generated__numberOfLaunches = $generated__numberOfLaunches;
    this.failureProbability = failureProbability;
    this.numberOfFailures = numberOfFailures;
  }
  
  /**
   * A component can be either a distribution, support constraint, or another model  
   * which recursively defines additional components.
   */
  public Collection<ModelComponent> components() {
    ArrayList<ModelComponent> components = new ArrayList();
    
    { // Code generated by: failureProbability | mu, s ~ BetaMeanParam(mu, s)
      // Construction and addition of the factor/model:
      components.add(
        new ex.hm.BetaMeanParam(
          $generated__0($generated__mu.get(), $generated__s.get(), $generated__numberOfLaunches.get(), failureProbability, numberOfFailures), 
          new $generated__1_class($generated__mu, $generated__s), 
          new $generated__2_class($generated__mu, $generated__s)
        )
        );
    }
    { // Code generated by: numberOfFailures | failureProbability, numberOfLaunches ~ Binomial(numberOfLaunches, failureProbability)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.Binomial(
          $generated__3($generated__mu.get(), $generated__s.get(), $generated__numberOfLaunches.get(), failureProbability, numberOfFailures), 
          new $generated__4_class(failureProbability, $generated__numberOfLaunches), 
          new $generated__5_class(failureProbability, $generated__numberOfLaunches)
        )
        );
    }
    
    return components;
  }
}
