require("ggplot2")
require("dplyr")

data <- read.csv("/Users/bouchard/w/blogobayes/www/ex/hm/results/all/Hierarchical--978298422/samples/failureProbabilities.csv")

# ggplot has bad default sizes for large facetting
verticalSize <- 2.0 *  length(unique(data$rockettype)) 
horizontalSize <- 4.0


p <- ggplot(data, aes(x = sample, y = value)) +
  geom_point(size = 0.1) + geom_line(alpha = 0.5) + facet_grid(rockettype ~ .
  , scales="free") + 
  theme_bw() + 
  xlab("MCMC iteration") +
  ylab("sample") +
  ggtitle("Trace plot for: failureProbabilities")
ggsave("/Users/bouchard/w/blogobayes/www/ex/hm/results/all/Hierarchical--978298422/tracePlotsFull/failureProbabilities.pdf", limitsize = F, height = verticalSize, width = horizontalSize)
